﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace StorageHelper.CF3_5Wrapper
{
		public static class File
		{
				private static Encoding enc = Encoding.Default;


				public static void WriteAllText(string _FileName, string _Content)
				{
						FileStream fs = System.IO.File.Create(_FileName);
						Byte[] content = enc.GetBytes(_Content);
						fs.Write(content, 0, content.Count<Byte>());
						fs.Close();

				}
				public static string ReadAllText(string _filename)
				{
						FileStream fs = System.IO.File.OpenRead(_filename);


						List<byte> ret = new List<byte>();
						for (int i = 0; i < fs.Length; i++)
						{
								ret.Add(Convert.ToByte(fs.ReadByte()));
						}
						fs.Close();
						return enc.GetString(ret.ToArray(), 0, ret.Count);
				}
		}
}
