﻿/// <typ>ConnectionString</typ>
/// <file>ConnectionString.cs</file>
/// <create>22.01.2011 15:48:31</crate>
/// <author>Wolfgang Stelzhammer</author>
///
/// <summary>
///
/// </summary>
/// <copyright>Copyright © 2008-2011 Wolfgang Stelzhammer, All rights reserved!</copyright>
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace StorageHelper.StorageAttributes
{
		[AttributeUsage(AttributeTargets.Class, Inherited = false, AllowMultiple = true)]
		public class ConnectionStringAttribute : Attribute
		{
				public ConnectionStringAttribute(string _ConnectionStringValue)
				{
						this.Value = _ConnectionStringValue;
				}

				public string Value
				{
						get;
						protected set;
				}
		}
}