﻿/// <typ>IdDigits</typ>
/// <file>IdDigits.cs</file>
/// <create>19.05.2011 01:15:46</crate>
/// <author>Wolfgang Stelzhammer</author>
///
/// <summary>
///
/// </summary>
/// <copyright>Copyright © 2008-2011 Wolfgang Stelzhammer, All rights reserved!</copyright>
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace StorageHelper.StorageAttributes
{
		/// <summary>
		/// A Property-Digits with a UniqIDAttribute is used for an Unique Identifier. An optionally given Prefix would be added in front of the Propery-Digits then.
		/// </summary>
		[AttributeUsage(AttributeTargets.Class, AllowMultiple = false, Inherited = true)]
		public class IdDigitsAttribute : Attribute
		{
				public int Digits
				{
						get;
						private set;
				}

				//public UniqIDAttribute()
				//{
				//  Digits = "";
				//}

				public IdDigitsAttribute(int _Digits)
				{
						Digits = _Digits;
				}
		}
}