﻿/// <typ>XmlFile_DEPRICATED</typ>
/// <file>XmlFile_DEPRICATED.cs</file>
/// <create>22.01.2011 17:17:30</crate>
/// <author>Wolfgang Stelzhammer</author>
///
/// <summary>
///
/// </summary>
/// <copyright>Copyright © 2008-2011 Wolfgang Stelzhammer, All rights reserved!</copyright>
#if DEPRICATED
using System;
using System.Collections.Generic;

#if CF3_5
using FileWrapper = StorageHelper.CF3_5Wrapper;
#else

using FileWrapper = System.IO;

#endif

using System.Linq;
using System.Reflection;
using System.Text;
using System.Xml;

using System.IO;

using System.Xml.Serialization;
using StorageHelper.StorageLib;
using StorageHelper.StorageLib.Depricated;

namespace StorageHelper.StorageEngines
{
		public class XmlFile_DEPRICATED : StorageEngine_DEPRICATED
		{
				public string FileExtension = ".xml";
				private string FileName;

				public override void Init()
				{
						if (!Directory.Exists(this.ConnectionString))
								throw new ConnectionStringNotExistingException(this.ConnectionString, this);
						if (CustomConfigParam != null && (string)CustomConfigParam != string.Empty)
								FileExtension = "." + (string)CustomConfigParam;
						foreach (string dir in this.SectionNames)
						{
								string tDir = ConnectionString + @"\" + dir;

								if (!Directory.Exists(tDir))
								{
										Directory.CreateDirectory(tDir);
								}
						}
						FileName = UniqID + FileExtension;
				}

				public override void Save()
				{
						FileName = UniqID + FileExtension;
						XmlSerializer serializer = new XmlSerializer(typeof(StorageSection));

						//foreach (KeyValuePair<string, StorageSection> sect in PropertiesSectionNames)
						//{
						//  StringWriter sw = new StringWriter();

						//  serializer.Serialize(sw, sect.Digits);
						//  FileWrapper.File.WriteAllText(ConnectionString + "\\" + sect.Key + "\\" + FileName, sw.ToString());
						//}
				}

				public override void Delete()
				{
						FileName = UniqID + FileExtension;
						System.IO.File.Delete(FileName);
				}

				public override void Clear()
				{
						this.Save();
				}

				public override object GetObject(string _uniqID)
				{
						return new object();
				}

				public override List<Object> GetAllObjects()
				{
						return new List<Object>();
				}

				//public override List<StorageSection> GetAllObjects()
				//{
				//  InitToConversion();
				//  List<StorageSection> ret = new List<StorageSection>();
				//  XmlSerializer serializer = new XmlSerializer(typeof(StorageSection));

				//  foreach (KeyValuePair<string, StorageSection> sec in PropertiesSectionNames)
				//  {
				//    string[] files = Directory.GetFiles(ConnectionString + "\\" + sec.Key + "\\");
				//    foreach (string file in files)
				//    {
				//      string strg = FileWrapper.File.ReadAllText(file);
				//      StringReader reader = new StringReader(strg);
				//      ret.Add((StorageSection)serializer.Deserialize(reader));
				//    }
				//  }

				//  return ret;
				//}

				//public override Dictionary<string, StorageSection> GetObject()
				//{
				//  FileName = UniqID + FileExtension;
				//  XmlSerializer serializer = new XmlSerializer(typeof(StorageSection));
				//  Dictionary<string, StorageSection> newSection = new Dictionary<string, StorageSection>();

				//  foreach (KeyValuePair<string, StorageSection> sect in PropertiesSectionNames)
				//  {
				//    string FilePath = ConnectionString + "\\" + sect.Key + "\\" + FileName;
				//    if (System.IO.File.Exists(FilePath))
				//    {
				//      string strg = FileWrapper.File.ReadAllText(FilePath);
				//      StringReader reader = new StringReader(strg);
				//      try
				//      {
				//        newSection.Add(sect.Key, (StorageSection)serializer.Deserialize(reader));
				//      }
				//      catch (Exception)
				//      {
				//        newSection.Add(sect.Key, sect.Digits);
				//      }
				//    }
				//    else
				//      newSection.Add(sect.Key, sect.Digits);
				//  }
				//  return newSection;
				//}
				public override int getNextAutoIncrement()
				{
						return 0;
				}
		}
}
#endif