﻿//using System;
//using System.Collections.Generic;
//using Microsoft.VisualStudio.TestTools.UnitTesting;
//using StorageHelper.StorageLib;
//
//namespace StorageHelperTest.StorageLib
//{
//		/// <summary>
//		///Dies ist eine Testklasse für "TypeConverterTest" und soll
//		///alle TypeConverterTest Komponententests enthalten.
//		///</summary>
//		[TestClass()]
//		public class TypeConverterTest
//		{
//				private TestContext testContextInstance;
//
//				/// <summary>
//				///Ruft den Testkontext auf, der Informationen
//				///über und Funktionalität für den aktuellen Testlauf bietet, oder legt diesen fest.
//				///</summary>
//				public TestContext TestContext
//				{
//						get
//						{
//								return testContextInstance;
//						}
//						set
//						{
//								testContextInstance = value;
//						}
//				}
//
//				#region Zusätzliche Testattribute
//
//				//
//				//Sie können beim Verfassen Ihrer Tests die folgenden zusätzlichen Attribute verwenden:
//				//
//				//Mit ClassInitialize führen Sie Code aus, bevor Sie den ersten Test in der Klasse ausführen.
//				//[ClassInitialize()]
//				//public static void MyClassInitialize(TestContext testContext)
//				//{
//				//}
//				//
//				//Mit ClassCleanup führen Sie Code aus, nachdem alle Tests in einer Klasse ausgeführt wurden.
//				//[ClassCleanup()]
//				//public static void MyClassCleanup()
//				//{
//				//}
//				//
//				//Mit TestInitialize können Sie vor jedem einzelnen Test Code ausführen.
//				//[TestInitialize()]
//				//public void MyTestInitialize()
//				//{
//				//}
//				//
//				//Mit TestCleanup können Sie nach jedem einzelnen Test Code ausführen.
//				//[TestCleanup()]
//				//public void MyTestCleanup()
//				//{
//				//}
//				//
//
//				#endregion Zusätzliche Testattribute
//
//				private int StdConverters = TypeConverter_Accessor.StdConverterCount;
//
//				private static void TypeReset()
//				{
//						TypeConverter_Accessor._FromDelegater = new Dictionary<string, TypeConverter.FromDelegate>();
//						TypeConverter_Accessor._ToDelegater = new Dictionary<string, TypeConverter.ToDelegate>();
//						TypeConverter_Accessor._StdConverters = new List<string>();
//						TypeConverter_Accessor.StdConvertersInited = false;
//				}
//
//				/// <summary>
//				///Ein Test für "InitFromConversion"
//				///</summary>
//				[TestMethod()]
//				[DeploymentItem("StorageHelper.dll")]
//				public void InitFromConversionTest()
//				{
//						TypeReset();
//						Assert.AreEqual(TypeConverter.FromDelegater.Count, StdConverters, "Fehler in Initialiesierung");
//				}
//
//				/// <summary>
//				///Ein Test für "InitToConversion"
//				///</summary>
//				[TestMethod()]
//				[DeploymentItem("StorageHelper.dll")]
//				public void InitToConversionTest()
//				{
//						TypeReset();
//						Assert.AreEqual(TypeConverter.ToDelegater.Count, StdConverters, "Fehler in Initialiesierung");
//				}
//
//				#region StdConverter Test
//
//				/// <summary>
//				///Ein Test für Int32
//				///</summary>
//				[TestMethod()]
//				[DeploymentItem("StorageHelper.dll")]
//				public void Int32Test()
//				{
//						Int32 ObjExpected = 55;
//						String StrExpected = "55";
//
//						String StrActual = TypeConverter.FromDelegater["Int32"](ObjExpected);
//						Int32 ObjActual = (Int32)TypeConverter.ToDelegater["Int32"](StrExpected);
//
//						Assert.AreEqual(StrExpected, StrActual, "Fehler bei From-Convertion");
//						Assert.AreEqual(ObjExpected, ObjActual, "Fehler bei To-Convertion");
//				}
//
//				/// <summary>
//				///Ein Test für String
//				///</summary>
//				[TestMethod()]
//				[DeploymentItem("StorageHelper.dll")]
//				public void StringTest()
//				{
//						String ObjExpected = "55";
//						String StrExpected = "55";
//
//						String StrActual = TypeConverter.FromDelegater["String"](ObjExpected);
//						String ObjActual = (String)TypeConverter.ToDelegater["String"](StrExpected);
//
//						Assert.AreEqual(StrExpected, StrActual, "Fehler bei From-Convertion");
//						Assert.AreEqual(ObjExpected, ObjActual, "Fehler bei To-Convertion");
//				}
//
//				/// <summary>
//				///Ein Test für Int16
//				///</summary>
//				[TestMethod()]
//				[DeploymentItem("StorageHelper.dll")]
//				public void Int16Test()
//				{
//						Int16 ObjExpected = 55;
//						String StrExpected = "55";
//
//						String StrActual = TypeConverter.FromDelegater["Int16"](ObjExpected);
//						Object ObjActual = TypeConverter.ToDelegater["Int16"](StrExpected);
//
//						Assert.AreEqual(StrExpected, StrActual, "Fehler bei From-Convertion");
//						Assert.AreEqual(ObjExpected, ObjActual, "Fehler bei To-Convertion");
//				}
//
//				/// <summary>
//				///Ein Test für int
//				///</summary>
//				[TestMethod()]
//				[DeploymentItem("StorageHelper.dll")]
//				public void IntTest()
//				{
//						int ObjExpected = 55;
//						String StrExpected = "55";
//
//						String StrActual = TypeConverter.FromDelegater["int"](ObjExpected);
//						Object ObjActual = TypeConverter.ToDelegater["int"](StrExpected);
//
//						Assert.AreEqual(StrExpected, StrActual, "Fehler bei From-Convertion");
//						Assert.AreEqual(ObjExpected, ObjActual, "Fehler bei To-Convertion");
//				}
//
//				/// <summary>
//				///Ein Test für Boolean = true
//				///</summary>
//				[TestMethod()]
//				[DeploymentItem("StorageHelper.dll")]
//				public void BooleanTrueTest()
//				{
//						Boolean ObjExpected = true;
//						String StrExpected = "true";
//
//						String StrActual = TypeConverter.FromDelegater["Boolean"](ObjExpected);
//						Object ObjActual = TypeConverter.ToDelegater["Boolean"](StrExpected);
//
//						Assert.AreEqual(StrExpected, StrActual, "Fehler bei From-Convertion");
//						Assert.AreEqual(ObjExpected, ObjActual, "Fehler bei To-Convertion");
//				}
//
//				/// <summary>
//				///Ein Test für Boolean = false
//				///</summary>
//				[TestMethod()]
//				[DeploymentItem("StorageHelper.dll")]
//				public void BooleanFalseTest()
//				{
//						Boolean ObjExpected = false;
//						String StrExpected = "false";
//
//						String StrActual = TypeConverter.FromDelegater["Boolean"](ObjExpected);
//						Object ObjActual = TypeConverter.ToDelegater["Boolean"](StrExpected);
//
//						Assert.AreEqual(StrExpected, StrActual, "Fehler bei From-Convertion");
//						Assert.AreEqual(ObjExpected, ObjActual, "Fehler bei To-Convertion");
//				}
//
//				/// <summary>
//				///Ein Test für DateTime
//				///</summary>
//				[TestMethod()]
//				[DeploymentItem("StorageHelper.dll")]
//				public void DateTimeTest()
//				{
//						DateTime ObjExpected = new DateTime(2011, 10, 6, 1, 18, 0, 0, DateTimeKind.Local);
//						String StrExpected = "<?xml version=\"1.0\" encoding=\"utf-16\"?>\r\n<dateTime>2011-10-05T23:18:00Z</dateTime>";
//
//						String StrActual = TypeConverter.FromDelegater["DateTime"](ObjExpected);
//						Object ObjActual = TypeConverter.ToDelegater["DateTime"](StrExpected);
//
//						Assert.AreEqual(StrExpected, StrActual, "Fehler bei From-Convertion");
//						Assert.AreEqual(ObjExpected, ObjActual, "Fehler bei To-Convertion");
//				}
//
//				/// <summary>
//				///Ein Test für Decimal
//				///</summary>
//				[TestMethod()]
//				[DeploymentItem("StorageHelper.dll")]
//				public void DecimalTest()
//				{
//						Decimal ObjExpected = (Decimal)55.55;
//						String StrExpected = "55,55";
//
//						String StrActual = TypeConverter.FromDelegater["Decimal"](ObjExpected);
//						Object ObjActual = TypeConverter.ToDelegater["Decimal"](StrExpected);
//
//						Assert.AreEqual(StrExpected, StrActual, "Fehler bei From-Convertion");
//						Assert.AreEqual(ObjExpected, ObjActual, "Fehler bei To-Convertion");
//				}
//
//				/// <summary>
//				///Ein Test für Double
//				///</summary>
//				[TestMethod()]
//				[DeploymentItem("StorageHelper.dll")]
//				public void DoubleTest()
//				{
//						Double ObjExpected = (Double)55.12;
//						String StrExpected = "55,12";
//
//						String StrActual = TypeConverter.FromDelegater["Double"](ObjExpected);
//						Object ObjActual = TypeConverter.ToDelegater["Double"](StrExpected);
//
//						Assert.AreEqual(StrExpected, StrActual, "Fehler bei From-Convertion");
//						Assert.AreEqual(ObjExpected, ObjActual, "Fehler bei To-Convertion");
//				}
//
//				/// <summary>
//				///Ein Test für Guid
//				///</summary>
//				[TestMethod()]
//				[DeploymentItem("StorageHelper.dll")]
//				public void GuidTest()
//				{
//						Guid ObjExpected = new Guid("66796DF2-5750-4A9E-A1AA-8508B07628E6".ToLower());
//						String StrExpected = "66796DF2-5750-4A9E-A1AA-8508B07628E6".ToLower();
//
//						String StrActual = TypeConverter.FromDelegater["Guid"](ObjExpected);
//						Object ObjActual = TypeConverter.ToDelegater["Guid"](StrExpected);
//
//						Assert.AreEqual(StrExpected, StrActual, "Fehler bei From-Convertion");
//						Assert.AreEqual(ObjExpected, ObjActual, "Fehler bei To-Convertion");
//				}
//
//				/// <summary>
//				///Ein Test für SByte
//				///</summary>
//				[TestMethod()]
//				[DeploymentItem("StorageHelper.dll")]
//				public void SByteTest()
//				{
//						SByte ObjExpected = 55;
//						String StrExpected = "55";
//
//						String StrActual = TypeConverter.FromDelegater["SByte"](ObjExpected);
//						Object ObjActual = TypeConverter.ToDelegater["SByte"](StrExpected);
//
//						Assert.AreEqual(StrExpected, StrActual, "Fehler bei From-Convertion");
//						Assert.AreEqual(ObjExpected, ObjActual, "Fehler bei To-Convertion");
//				}
//
//				/// <summary>
//				///Ein Test für Single
//				///</summary>
//				[TestMethod()]
//				[DeploymentItem("StorageHelper.dll")]
//				public void SingleTest()
//				{
//						Single ObjExpected = (Single)55.214;
//						String StrExpected = "55,214";
//
//						String StrActual = TypeConverter.FromDelegater["Single"](ObjExpected);
//						Object ObjActual = TypeConverter.ToDelegater["Single"](StrExpected);
//
//						Assert.AreEqual(StrExpected, StrActual, "Fehler bei From-Convertion");
//						Assert.AreEqual(ObjExpected, ObjActual, "Fehler bei To-Convertion");
//				}
//
//				/// <summary>
//				///Ein Test für TimeSpan
//				///</summary>
//				[TestMethod()]
//				[DeploymentItem("StorageHelper.dll")]
//				public void TimeSpanTest()
//				{
//						TimeSpan ObjExpected = new TimeSpan(10, 10, 10, 10, 10);
//
//						String StrExpected = "9006100100000";
//
//						String StrActual = TypeConverter.FromDelegater["TimeSpan"](ObjExpected);
//						Object ObjActual = TypeConverter.ToDelegater["TimeSpan"](StrExpected);
//
//						Assert.AreEqual(StrExpected, StrActual, "Fehler bei From-Convertion");
//						Assert.AreEqual(ObjExpected, ObjActual, "Fehler bei To-Convertion");
//				}
//
//				#endregion StdConverter Test
//
//				/// <summary>
//				///Ein Test für "StdConverters"
//				///</summary>
//				[TestMethod()]
//				public void StdConvertersTest()
//				{
//						TypeReset();
//						List<string> actual;
//						actual = TypeConverter.StdConverters;
//						Assert.AreEqual(StdConverters, actual.Count, "Fehler in Standardconverter-Ermittlung.");
//				}
//
//				/// <summary>
//				/// Ein Test für das Hinzufügen von Convertern
//				/// </summary>
//				[TestMethod()]
//				public void addConverterVorhandenTest()
//				{
//						TypeReset();
//						TypeConverter_Accessor.InitStdConverters();
//						try
//						{
//								TypeConverter.addConverter("Int32", TypeConverter_Accessor.To.Int32, TypeConverter_Accessor.From.Int32);
//						}
//						catch (TypeConverterException e)
//						{
//								Assert.AreEqual(e.ExceptionType, TypeConverterException.ExceptionTypes.ContainsType, "Fehlerhafte TypeConverterExecption wurde geworfen!");
//						}
//						catch (Exception)
//						{
//								Assert.Fail("Es wurde eine Fehlerhafte Exeception geworfen");
//						}
//				}
//
//				/// <summary>
//				/// Ein Test für das Hinzufügen von Convertern
//				/// </summary>
//				[TestMethod()]
//				public void addConverterFullResetVorhandenTest()
//				{
//						TypeReset();
//						try
//						{
//								TypeConverter.addConverter("Int32", TypeConverter_Accessor.To.Int32, TypeConverter_Accessor.From.Int32);
//						}
//						catch (TypeConverterException e)
//						{
//								Assert.AreEqual(e.ExceptionType, TypeConverterException.ExceptionTypes.ContainsType, "Fehlerhafte TypeConverterExecption wurde geworfen!");
//						}
//						catch (Exception)
//						{
//								Assert.Fail("Es wurde eine Fehlerhafte Exeception geworfen");
//						}
//				}
//
//				/// <summary>
//				/// Überprüft ob ein Vorhandenener und nichtStd-Converter gelöscht wird.
//				/// </summary>
//				[TestMethod()]
//				public void removeConverterTest()
//				{
//						TypeReset();
//						string converterName = "TestInt32";
//						TypeConverter.addConverter(converterName, TypeConverter_Accessor.To.Int32, TypeConverter_Accessor.From.Int32);
//						Assert.IsTrue(TypeConverter.FromDelegater.ContainsKey(converterName), "TypeConverter ist nicht in FromDelegater vorhanden");
//						Assert.IsTrue(TypeConverter.ToDelegater.ContainsKey(converterName), "TypeConverter ist nicht in ToDelegater vorhanden");
//
//						TypeConverter.removeConverter(converterName);
//						Assert.IsFalse(TypeConverter.FromDelegater.ContainsKey(converterName), "TypeConverter ist noch immer in FromDelegater vorhanden");
//						Assert.IsFalse(TypeConverter.ToDelegater.ContainsKey(converterName), "TypeConverter ist noch immer in ToDelegater vorhanden");
//				}
//
//				/// <summary>
//				/// Überprüft ob Std-Converter gelöscht wird.
//				/// </summary>
//				[TestMethod()]
//				public void removeConverterStdConverterTest()
//				{
//						TypeReset();
//						string converterName = "Int32";
//
//						try
//						{
//								TypeConverter.removeConverter(converterName);
//						}
//						catch (TypeConverterException e)
//						{
//								Assert.AreEqual(TypeConverterException.ExceptionTypes.isStdType, e.ExceptionType, "Es wurde einer fehlerhafte TypeConverterException.Type geworfen");
//						}
//						catch (Exception)
//						{
//								Assert.Fail("Es wurde eine Fehlerhafte Exception geworfen.");
//						}
//						Assert.IsTrue(TypeConverter.ToDelegater.ContainsKey(converterName), "StdConverter wurde fehlerhafterweise gelöscht");
//						Assert.IsTrue(TypeConverter.FromDelegater.ContainsKey(converterName), "StdConverter wurde fehlerhafterweise gelöscht");
//				}
//
//				/// <summary>
//				/// Überprüft ob bei nicht vorhandenem Converter eine Fehlermeldung geworfen wird.
//				/// </summary>
//				[TestMethod()]
//				public void removeConverterNotExistingTest()
//				{
//						TypeReset();
//						string converterName = "asdfsdfasdfsdfsdfsdfsdwefwefsdcvcwf";
//
//						try
//						{
//								TypeConverter.removeConverter(converterName);
//						}
//						catch (TypeConverterException e)
//						{
//								Assert.AreEqual(TypeConverterException.ExceptionTypes.notContainsType, e.ExceptionType, "Es wurde einer fehlerhafte TypeConverterException.Type geworfen");
//						}
//						catch (Exception)
//						{
//								Assert.Fail("Es wurde eine Fehlerhafte Exception geworfen.");
//						}
//				}
//		}
//}