﻿/// <typ>DeserializeExeception</typ>
/// <file>DeserializeExeception.cs</file>
/// <create>22.09.2011 04:07:41</crate>
/// <author>Wolfgang Stelzhammer</author>
///
/// <summary>
///
/// </summary>
/// <copyright>Copyright © 2008-2011 Wolfgang Stelzhammer, All rights reserved!</copyright>
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace StorageHelper.StorageLib
{
		public class DeserializeExeception : Exception
		{
				public enum TypeContentFailures
				{
						General = 0,
						XmlStringEmty,
				}

				public TypeContentFailures Failure
				{
						get;
						private set;
				}

				public DeserializeExeception()
						: base("Fehler bei der Deserialisierung.")
				{
						Failure = TypeContentFailures.General;
				}

				public DeserializeExeception(TypeContentFailures failure)
						: base(failure.ToString() + "-Fehler bei der Deserialisierung.")
				{
						Failure = failure;
				}
		}
}