﻿/// <typ>IStorageHelper</typ>
/// <file>IStorageHelper.cs</file>
/// <create>14.09.2011 22:48:51</crate>
/// <author>Wolfgang Stelzhammer</author>
///
/// <summary>
///
/// </summary>
/// <copyright>Copyright © 2008-2011 Wolfgang Stelzhammer, All rights reserved!</copyright>
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using StorageHelper.StorageBase;

namespace StorageHelper.StorageLib
{
		public interface IStorageHelper
		{
				int Id
				{
						get;
						set;
				}

				string ConnectionString
				{
						get;
				}

				int IdDigits
				{
						get;
				}

				bool AutoSave
				{
						get;
						set;
				}

				bool isSticky
				{
						get;
				}

				bool isNew
				{
						get;
				}

				string UniqID
				{
						get;
				}

				void addCustomEngineParameter(Dictionary<string, object> ParameterDic);

				void Save();

				void Delete();

				void Clear();

				//void UpdateInstance();

				event StorageHelperType.StorageHelperEventHandler SaveEvent;
				event StorageHelperType.StorageHelperEventHandler DeleteEvent;
				event StorageHelperType.StorageHelperEventHandler ClearEvent;

				//T returnObject<T>(string _uniqID);
				//List<T> returnAllObjects<T>();
		}
}