﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace StorageHelper.StorageLib
{
		public class StateInfo
		{
				public int Id = 0;

				public bool isSticky = true;

				private bool _isNew = true;

				public bool isNew
				{
						get
						{
								return _isNew;
						}
						set
						{
								_isNew = value;
								if (!value)
										TypeInfo.TypeContentsCollection[UniqID] = this.PropertiesContent;
						}
				}

				private TypeContent _tempPropertiesContent = new TypeContent();

				public TypeContent PropertiesContent
				{
						get
						{
								if (isNew)
								{
										return _tempPropertiesContent;
								}
								else
								{
										if (!TypeInfo.TypeContentsCollection.ContainsKey(UniqID))
												TypeInfo.TypeContentsCollection[UniqID] = new TypeContent();
										return TypeInfo.TypeContentsCollection[UniqID];
								}
						}
						set
						{
								if (isNew)
								{
										_tempPropertiesContent = value;
								}
								else
								{
										TypeInfo.TypeContentsCollection[UniqID] = value;
								}
						}
				}

				private string _UniqID = string.Empty;

				public string UniqID
				{
						get
						{
								return _UniqID;
						}
						set
						{
								string OldValue = _UniqID;
								string NewValue = value;

								_UniqID = value;

								if (!TypeInfo.TypeContentsCollection.ContainsKey(OldValue))
										TypeInfo.TypeContentsCollection[NewValue] = _tempPropertiesContent;
								else
										TypeInfo.TypeContentsCollection[NewValue] = TypeInfo.TypeContentsCollection[OldValue];
						}
				}

				private TypeInfo TypeInfo;

				public StateInfo(TypeInfo TInfo)
				{
						TypeInfo = TInfo;
						//PropertiesContent = new TypeContent();
				}
		}
}