﻿using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Reflection;
using System.Text;
using StorageHelper.StorageBase;

namespace StorageHelper.StorageLib
{
		public abstract class StorageEngine : IStorageEngine
		{
				public Dictionary<string, object> CustonConfig
				{
						get;
						set;
				}

				public TypeInfo TypeInfo
				{
						get;
						private set;
				}

				public abstract void Save(StorageHelperType sender, StorageHelperEventArgs e);

				public abstract void Delete(StorageHelperType sender, StorageHelperEventArgs e);

				public abstract int getNextAutoIncrement();

				public abstract void GetAllContent(ConcurrentObservableDictionary<string, TypeContent> ContentCollection);

				public virtual void Init(TypeInfo TInfo)
				{
						TypeInfo = TInfo;
				}

				//public virtual void Init(StateInfo _StateInfo, TypeInfo TInfo)
				//{
				//  StateInfo = _StateInfo;
				//  TypeInfo = TInfo;
				//}

				public StorageEngine()
				{
				}

				public StorageEngine(TypeInfo TInfo)
				{
						Init(TInfo);
				}

				//public StorageEngine(StateInfo _StateInfo, TypeInfo TInfo)
				//{
				//  Init(_StateInfo, TInfo);
				//}
		}
}