﻿/// <typ>TypeInfo</typ>
/// <file>TypeInfo.cs</file>
/// <create>22.09.2011 00:24:17</crate>
/// <author>Wolfgang Stelzhammer</author>
///
/// <summary>
///
/// </summary>
/// <copyright>Copyright © 2008-2011 Wolfgang Stelzhammer, All rights reserved!</copyright>
using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Xml.Serialization;
using StorageHelper.StorageEngines;

namespace StorageHelper.StorageLib
{
		public class TypeInfo
		{
				// TypeContent only usefull in an Live Object not in an Static
				//xpublic TypeContent Content = new TypeContent();

				public StorageEngine Engine;

				public Dictionary<string, PropertyInfo> PropertyInfo;

				public Dictionary<string, string> UniqIDs;

				public string TypeName;

				public Type TypeReflection;

				public string TypeCollectionName;

				public List<string> ExcludedProperties;

				public string ConnectionString;

				public bool initedStatic = false;

				public const int _IDIGITS = 6;

				public int IdDigits = _IDIGITS;

				public const StorageEnginesEnum _STDEngine = StorageEnginesEnum.SimpleXmlFile;

				public bool AutoSave = false;

				public string DigitFormat
				{
						get
						{
								string ret = string.Empty;
								for (int i = 0; i < IdDigits; i++)
								{
										ret += "0";
								}
								return ret;
						}
				}

				public ConcurrentObservableDictionary<string, TypeContent> TypeContentsCollection = new ConcurrentObservableDictionary<string, TypeContent>();

				public ObservableDictionary<string, object> ObjectCollection = new ObservableDictionary<string, object>();

				public int tempCounter = 0;
		}
}