﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace StorageHelper.StorageLib
{
		public class StaticTypeInfo
		{
				public StorageEngines.StorageEnginesEnum InternalStorageEngine
				{
						set
						{
								StorageEngine = (StorageEngine)Activator.CreateInstance(Type.GetType("StorageHelper.StorageEngines." + value.ToString()));
						}
				}

				public string ConnectionString = null;
				public int IdDigits = 0;
				public StorageEngine StorageEngine = null;
				public Dictionary<string, object> EngineCustomParameter = null;
				public bool AutoSave = false;
				public string TypeName;
				public string TypeCollectionName;
		}
}